Redmine - Feature #559

Workflow Enhancements
2008-01-16 08:08 - Geordee Naliyath

Status: New Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: Issues workflow Estimated time: 0.00 hour
Target version: Unplanned backlogs

Resolution:

Description

Here are some suggestions to enhance workflow:
1. Ability to hide unused statuses in workflow definition

At applications level we create many statuses and use only the appropriate ones for creating different workflows. This
creates large number of options when we are at workflow definition screen and it's very difficult to work with or understand

the workflows. We can do either of the following two options to make workflow definitions easier.

a. Use AJAX to hide unused statuses

b. Create ability to add/remove statuses for a particular workflow from the global set

2. Workflow visualization

Once the workflow is defined, if it can be represented in a decision tree either pictorially or using some formatted
table it could be easier to manage. | was thinking of converting organizational processes into Redmine workflow, and
a pictorial representation will appear as the process definition. Conditions for status changes may be missing in this

workflow - that would make it too complicated as well - and that is OK.

Related issues:
Related to Redmine - Feature #12878: Visualize a tracker's workflow graphically

Related to Redmine - Feature #2448: Graphviz of ticket dependencies (with exa...

Related to Redmine - Feature #12647: issue relations network view

Closed
New 2009-01-06
New

History

#1 - 2009-07-25 19:18 - Nikolay Kotlyarov

| think my problem is the same as point 1 above, but supposed solution differs..

The are two problems in our company:(Redmine 8.0)

1. Project "SomePrj" needs personal workflow "SomePrjWorkflow". Project "AnotherPrj" also needs personal workflow "AnothePrjWorkflow" that
resembles "SomePrjWorkflow" but not the same. Project "ThirdPrj" needs a workflow that is completely different from "Some" and "Another". And

all of them want to use same statuses for tickets.
But there is only one workflow in Redmine and it affects all projects:(

2. In project "SomePrj" most of the issues must subordinate "SomePrjWorkflow". They flowing from one person to another and have a number of
transitions before it is closed. But there are issues that can be closed in one or two transitions in a vary short period. If those issues would
subordinate standard workflow their lifetime would be much greater, for example: issue would wait some person(who is on a vacation) with

corresponding role just for " click me forward till SomeStatus ".

Most of the project issues must subordinate "SomePrjWorkflow". But there are "extra" cases when the issue must subordinate its custom

workflow. And those cases are not rare in practice.

Workaround:

1. For custom project "SomePrj" workflow we can create its own special statuses with an unique prefix/postfix: "[SomePrj]New",

"[SomePrjlAssigned”, "[SomePrj]Closed", etc.

2.1 dunno any:( Because of singular workflow people just do not create such "mini"-issues and try to resolve them by email. That method frequently

becomes even more time consuming..
So the requested features are:

e Per project workflow
e Per issue worklow

¢ Point 2 from Geordee: +1. Some visualization would be great, cause currently it's very easy to get tangled when the statuses number increases.

P.S. Sorry for my English, i know it's bad..
#2 - 2009-11-28 18:51 - Michael Ivanov

+1

#3 - 2009-12-01 11:43 - Emil Abdulnasyrov

+1

#4 - 2010-07-08 02:33 - Alex Last

I'd say +100. this is a killer feature, which would bring Redmine much closer to systems like Atlassian Jira.

#5 - 2010-10-19 14:17 - Florian ROBERT

- File wf_visu.JPG added

Hello,

+1

I'm sharing the workflow definition of more than 10 trackers with other project manager and it is quite difficult and time consuming to maintain a

document showing the states and transitions for everybody use.

An automatic generation of workflow visualisation like below will be great:
wf_visu.JPG

The color of the arrows represents the autorized transition by profile (manager, developper, customer)

#6 - 2010-12-13 07:31 - Dmitry Dusenbaev

+1

#7 - 2010-12-28 12:03 - Ruben Kruiswijk

+1

#8 - 2010-12-28 13:20 - Terence Mill

Checkout this for "Workflow visualization"

e http://www.redmine.org/boards/3/topics/5312

#9 - 2010-12-29 07:01 - Mischa The Evil
- File ro559-add_workflow_graphviz_graph-r4574.patch added

And here yet another implementation of a sort of "Workflow visualization" by Ryo SUETSUGU:

¢ [nitial blog post:

o http:/d.hatena.ne.jp/suer/20100820/redmine_viz
e Follow-up blog post:

o http:/d.hatena.ne.jp/suer/20100821/workflow_viz_plugin
e Quick 'n Dirty plugin introduced in second blog post:

o https://github.com/suer/redmine_workflow_viz

I myself have changed the patches/plugin-source slightly and maintain it as a private patch. I'll attach it to this issue (
ro559-add_workflow_graphviz_graph-r4574.patch).

#10 - 2010-12-29 11:25 - Terence Mill

We installed the workflow_graphviz plugin sucessfully on redmine 1.01.

#11 - 2011-03-24 08:38 - Toshi MARUYAMA

- Category set to Issues workflow

#12 - 2011-04-27 10:13 - Etienne Massip

- Target version set to Unplanned backlogs

#13 - 2011-05-01 15:40 - Anton Lem

Workflow visualisation +1

#14 - 2011-07-18 00:06 - Terence Mill
http://www.redmine.org/boards/3/topics/5312
http://d.hatena.ne.jp/suer/20100820/redmine_viz
http://d.hatena.ne.jp/suer/20100821/workflow_viz_plugin
https://github.com/suer/redmine_workflow_viz
https://www.redmine.org/attachments/5079
https://github.com/suer/redmine_workflow_viz

THe PLugin seems not to be maintained.
We reported some major bugs , but to response.
https://github.com/suer/redmine_workflow_viz/

#15 - 2012-01-23 14:51 - yannick quenec'hdu

+1

Your proposal is interesting. This implies that it is possible to make independent workflow per project, thus also independent issues statues by

workflow and for each project.

In view of the evolution of IT projects to Agile methods. Workflow view could be seen with a Kanban view.
A perhaps introduce the notion of limit in the work in progress

Anton Lem wrote:

Workflow visualisation +1

#16 - 2012-08-22 19:46 - @ go2null

Geordee Naliyath wrote:

Here are some suggestions to enhance workflow:

1. Ability to hide unused statuses in workflow definition

At applications level we create many statuses and use only the appropriate ones for creating different workflows. This
creates large number of options when we are at workflow definition screen and it's very difficult to work with or understand
the workflows. We can do either of the following two options to make workflow definitions easier.

a. Use AJAX to hide unused statuses

b. Create ability to add/remove statuses for a particular workflow from the global set

This seems to be covers by Feature #8050, due in v2.1.0.

#17 - 2012-08-24 22:38 - Anonymous

+1 I think it is very interesting

#18 - 2012-12-21 01:03 - Mikotaj Milej
- File workflows.jpg added

Everything's fine, everyone is happy, after adding #8050 redmine is better but ...

We have 16 trackers and ~23 roles which makes 368 pages with individual workflows!! Happy clicking!!

Many of them should be empty (role not allowed do change status in tracker) or they would be the same (eg. Team Leaders, 3d designer and texture

artist - similar role). So there would be many copy&paste which of course makes bugs and eats your time.

What's more. I've added new tracker then I've to set permissions for all team leaders which makes ~6 pages (but it could be something else, for all

roles :D).

In my opinion, there should be sth like "template workflow" which you can assing for role.

For eg. 10 roles need the same workflow so you assign for those roles your "template workflow". When you would like to change it then you have to

change only in one place istead of 10!

You added new role, tracker? It's fine! Select or modify one of your defined "template worklow" and it's done (instead of walk through 368 pages ...)!

+100 for that feature and those requested in this issue ;]

workflows.jpg

#19 - 2013-02-12 23:48 - Terence Mill

related:
Graphviz of ticket dependencies
issue relations network view

#20 - 2013-02-13 10:14 - Daniel Felix
Terence Mill wrote:
related:

Graphviz of ticket dependencies
issue relations network view

2025-05-01

3/5


https://github.com/suer/redmine_workflow_viz/
https://github.com/suer/redmine_workflow_viz/issues?sort=created&direction=desc&state=open&page=1
https://github.com/suer/redmine_workflow_viz/
https://www.redmine.org/issues/8050
http://www.redmine.org/versions/47
https://www.redmine.org/issues/8050
http://www.redmine.org/issues/2448
http://www.redmine.org/issues/12647
http://www.redmine.org/issues/12647
http://www.redmine.org/issues/12647

Uhm? Both links point to the same issue. Was this expected?
#21 - 2013-02-13 10:44 - Terence Mill
Daniel Felix wrote:
Terence Mill wrote:
related:

Graphviz of ticket dependencies
issue relations network view

Uhm? Both links point to the same issue. Was this expected?

Sry, fixed

#22 - 2013-02-26 19:32 - Pavel Lautsevich

+1 It very useful when i use Jira. So, i want this feature in Redmine!

#23 - 2013-02-27 12:07 - Benjamin Jeanjean

+1 ! Would be a really nice addition for Redmine !

#24 - 2013-04-24 11:04 - Francesco V

+1

#25 - 2014-07-25 00:00 - Daniel Ritz

A plugin for workflow enhancements in early stages. Currently only does a visualization with D3:
https://github.com/dr-itz/redmine_workflow enhancements

#26 - 2014-10-05 22:29 - Daniel Ritz

Daniel Ritz wrote:

A plugin for workflow enhancements in early stages. Currently only does a visualization with D3:
https://github.com/dr-itz/redmine_workflow enhancements

Just pushed an update that makes it possible to pre-define the issue statues for a tracker. Statuses defined in a tracker will show in the Workflow form
when the check box 'Only display statuses that are used by this tracker' is checked, regardless whether a status is already used or not.

#27 - 2020-08-18 07:36 - Seyyed Soroosh Hosseinalipour
ITNOA

It is very useful feature. please add this to Redmine.

Are you any plan to add this in next version?

#28 - 2020-11-11 10:50 - Fabrizio Sebastiani

Yes we also very agree: it doesn't make sense to manage workflow in such a sparse table with flags (checkboxes). Eyes become crazy to move
inside it, especially when status are many.

Visual mode could be very nice but not necessary: it would be enough to manage it by a fixed column transaction table holding the allowed
transactions, example:

tracker Current status Role Next status
Feature Working Reporter Working
Feature Working Developer Closed
Feature Working Developer Feedback
Feature Working Developer New
Bug New Manager Closed
Bug New Manager Feedback
Files

wf_visu.JPG 15.7 KB 2010-10-19 Florian ROBERT

ro559-add_workflow_graphviz_graph-r4574.patch 1.1 KB 2010-12-29 Mischa The Evil
64.1 KB 2012-12-21 Mikotaj Milej

workflows.jpg
